Index: trunk/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.Designer.cs	(revision 12143)
+++ trunk/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.Designer.cs	(revision 12458)
@@ -48,7 +48,7 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
-      System.Windows.Forms.DataVisualization.Charting.Legend legend1 = new System.Windows.Forms.DataVisualization.Charting.Legend();
-      System.Windows.Forms.DataVisualization.Charting.Series series1 = new System.Windows.Forms.DataVisualization.Charting.Series();
+      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea2 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
+      System.Windows.Forms.DataVisualization.Charting.Legend legend2 = new System.Windows.Forms.DataVisualization.Charting.Legend();
+      System.Windows.Forms.DataVisualization.Charting.Series series2 = new System.Windows.Forms.DataVisualization.Charting.Series();
       this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
       this.binsNumericUpDown = new System.Windows.Forms.NumericUpDown();
@@ -57,4 +57,5 @@
       this.label2 = new System.Windows.Forms.Label();
       this.bandwidthNumericUpDown = new System.Windows.Forms.NumericUpDown();
+      this.noDataLabel = new System.Windows.Forms.Label();
       ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
       ((System.ComponentModel.ISupportInitialize)(this.binsNumericUpDown)).BeginInit();
@@ -67,16 +68,16 @@
             | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      chartArea1.Name = "ChartArea1";
-      this.chart.ChartAreas.Add(chartArea1);
-      legend1.Alignment = System.Drawing.StringAlignment.Center;
-      legend1.Docking = System.Windows.Forms.DataVisualization.Charting.Docking.Top;
-      legend1.Name = "Default";
-      this.chart.Legends.Add(legend1);
+      chartArea2.Name = "ChartArea1";
+      this.chart.ChartAreas.Add(chartArea2);
+      legend2.Alignment = System.Drawing.StringAlignment.Center;
+      legend2.Docking = System.Windows.Forms.DataVisualization.Charting.Docking.Top;
+      legend2.Name = "Default";
+      this.chart.Legends.Add(legend2);
       this.chart.Location = new System.Drawing.Point(0, 27);
       this.chart.Name = "chart";
-      series1.ChartArea = "ChartArea1";
-      series1.Legend = "Default";
-      series1.Name = "Series1";
-      this.chart.Series.Add(series1);
+      series2.ChartArea = "ChartArea1";
+      series2.Legend = "Default";
+      series2.Name = "Series1";
+      this.chart.Series.Add(series2);
       this.chart.Size = new System.Drawing.Size(465, 336);
       this.chart.TabIndex = 0;
@@ -159,7 +160,18 @@
       this.bandwidthNumericUpDown.ValueChanged += new System.EventHandler(this.bandwidthNumericUpDown_ValueChanged);
       // 
+      // noDataLabel
+      // 
+      this.noDataLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.noDataLabel.AutoSize = true;
+      this.noDataLabel.Location = new System.Drawing.Point(163, 175);
+      this.noDataLabel.Name = "noDataLabel";
+      this.noDataLabel.Size = new System.Drawing.Size(139, 13);
+      this.noDataLabel.TabIndex = 22;
+      this.noDataLabel.Text = "No data could be displayed.";
+      // 
       // HistogramControl
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.noDataLabel);
       this.Controls.Add(this.label2);
       this.Controls.Add(this.bandwidthNumericUpDown);
@@ -186,4 +198,5 @@
     private System.Windows.Forms.Label label2;
     private System.Windows.Forms.NumericUpDown bandwidthNumericUpDown;
+    private System.Windows.Forms.Label noDataLabel;
   }
 }