Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/AllArchitectureAlteringOperatorsTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/AllArchitectureAlteringOperatorsTest.cs	(revision 12481)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/AllArchitectureAlteringOperatorsTest.cs	(revision 12482)
@@ -61,5 +61,5 @@
             // manipulate
             stopwatch.Start();
-            var selectedTree = (ISymbolicExpressionTree)trees.SelectRandom(random).Clone();
+            var selectedTree = (ISymbolicExpressionTree)trees.SampleRandom(random).Clone();
             var oldTree = (ISymbolicExpressionTree)selectedTree.Clone();
             bool success = false;
@@ -83,6 +83,6 @@
             SymbolicExpressionTree par1 = null;
             do {
-              par0 = (SymbolicExpressionTree)trees.SelectRandom(random).Clone();
-              par1 = (SymbolicExpressionTree)trees.SelectRandom(random).Clone();
+              par0 = (SymbolicExpressionTree)trees.SampleRandom(random).Clone();
+              par1 = (SymbolicExpressionTree)trees.SampleRandom(random).Clone();
             } while (par0.Length > MAX_TREE_LENGTH || par1.Length > MAX_TREE_LENGTH);
             var newTree = SubtreeCrossover.Cross(random, par0, par1, 0.9, MAX_TREE_LENGTH, MAX_TREE_DEPTH);
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubtreeCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubtreeCrossoverTest.cs	(revision 12481)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubtreeCrossoverTest.cs	(revision 12482)
@@ -50,6 +50,6 @@
       for (int gCount = 0; gCount < generations; gCount++) {
         for (int i = 0; i < POPULATION_SIZE; i++) {
-          var par0 = (ISymbolicExpressionTree)trees.SelectRandom(random).Clone();
-          var par1 = (ISymbolicExpressionTree)trees.SelectRandom(random).Clone();
+          var par0 = (ISymbolicExpressionTree)trees.SampleRandom(random).Clone();
+          var par1 = (ISymbolicExpressionTree)trees.SampleRandom(random).Clone();
           SubtreeCrossover.Cross(random, par0, par1, 0.9, 100, 10);
         }
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs	(revision 12481)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs	(revision 12482)
@@ -125,10 +125,10 @@
       stopwatch.Start();
       for (int i = 0; i != PopulationSize; ++i) {
-        var parent0 = (ISymbolicExpressionTree)trees.SelectRandom(twister).Clone();
+        var parent0 = (ISymbolicExpressionTree)trees.SampleRandom(twister).Clone();
         var scopeParent0 = new Scope();
         scopeParent0.Variables.Add(new Core.Variable(crossover.ParentsParameter.ActualName, parent0));
         context.Scope.SubScopes.Add(scopeParent0);
 
-        var parent1 = (ISymbolicExpressionTree)trees.SelectRandom(twister).Clone();
+        var parent1 = (ISymbolicExpressionTree)trees.SampleRandom(twister).Clone();
         var scopeParent1 = new Scope();
         scopeParent1.Variables.Add(new Core.Variable(crossover.ParentsParameter.ActualName, parent1));
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Util.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Util.cs	(revision 12481)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/Util.cs	(revision 12482)
@@ -79,5 +79,5 @@
     public static double CalculateEvaluatedNodesPerSec(ISymbolicExpressionTree[] trees, ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, Dataset dataset, int repetitions) {
       // warm up
-      IEnumerable<int> rows = Enumerable.Range(0, dataset.Rows);
+      IEnumerable<int> rows = Enumerable.Range(0, dataset.Rows).ToList();
       long nNodes = 0;
       double c = 0;